import { TemplateRef } from '@angular/core';
import RAPIER from '@dimforge/rapier3d-compat';
import { NgtrColliderStateMap, NgtrEventMap, NgtrPhysicsOptions, NgtrRigidBodyStateMap } from './types';
import * as i0 from "@angular/core";
export declare class NgtrPhysicsFallback {
    static ngTemplateContextGuard(_: NgtrPhysicsFallback, ctx: unknown): ctx is {
        error: string;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtrPhysicsFallback, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtrPhysicsFallback, "ng-template[rapierFallback]", never, {}, {}, never, never, true, never>;
}
export declare class NgtrPhysics {
    options: import("@angular/core").InputSignalWithTransform<NgtrPhysicsOptions, "" | Partial<NgtrPhysicsOptions>>;
    content: import("@angular/core").Signal<TemplateRef<any>>;
    fallbackContent: import("@angular/core").Signal<TemplateRef<any> | undefined>;
    protected updatePriority: import("@angular/core").Signal<number | undefined>;
    protected updateLoop: import("@angular/core").Signal<"follow" | "independent">;
    private numSolverIterations;
    private numAdditionalFrictionIterations;
    private numInternalPgsIterations;
    private allowedLinearError;
    private minIslandSize;
    private maxCcdSubsteps;
    private predictionDistance;
    private contactNaturalFrequency;
    private lengthUnit;
    private timeStep;
    private interpolate;
    paused: import("@angular/core").Signal<boolean>;
    debug: import("@angular/core").Signal<boolean>;
    colliders: import("@angular/core").Signal<import("angular-three-rapier").NgtrRigidBodyAutoCollider | undefined>;
    private vGravity;
    private store;
    protected rapierConstruct: import("@angular/core").WritableSignal<typeof RAPIER | null>;
    protected rapierError: import("@angular/core").WritableSignal<string | null>;
    rapier: import("@angular/core").Signal<typeof RAPIER | null>;
    ready: import("@angular/core").Signal<boolean>;
    worldSingleton: import("@angular/core").Signal<{
        proxy: RAPIER.World;
        reset: () => void;
        set: (newInstance: RAPIER.World) => void;
    } | null>;
    rigidBodyStates: NgtrRigidBodyStateMap;
    colliderStates: NgtrColliderStateMap;
    rigidBodyEvents: NgtrEventMap;
    colliderEvents: NgtrEventMap;
    private beforeStepCallbacks;
    private afterStepCallbacks;
    private eventQueue;
    private steppingState;
    constructor();
    step(delta: number): void;
    private updateWorldEffect;
    private internalStep;
    private getSourceFromColliderHandle;
    private getCollisionPayloadFromSource;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtrPhysics, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtrPhysics, "ngtr-physics", never, { "options": { "alias": "options"; "required": false; "isSignal": true; }; }, {}, ["content", "fallbackContent"], never, true, never>;
}
